#!/usr/bin/env python

import os
import sys

# ------------------------------------------------------------------------------
def read_template():
    lines = []
    head_lines = []
    body_lines = []

    still_in_head = True

    with open("node-template.yml", "r", newline="\n") as src_file:
        lines = src_file.readlines()

    for line in lines:
        if still_in_head:
            head_lines.append(line)
        else:
            body_lines.append(line)

        if "services:" in line:
            still_in_head = False

    return (head_lines, body_lines)


# ------------------------------------------------------------------------------
def generate_entry(
    config_file, body_lines, dht_algorithm, dht_node_port, join_dht_node_port
):
    no_depends_on = True

    for line in body_lines:
        print(
            line.format(
                dht_algorithm=dht_algorithm,
                dht_node_port=dht_node_port,
                join_dht_node_port=join_dht_node_port,
            ),
            end="",
            file=config_file,
        )

        if "depends_on:" in line:
            no_depends_on = False
            if dht_node_port != join_dht_node_port:
                print(f"      - node-{join_dht_node_port}", end="", file=config_file)

    if no_depends_on and dht_node_port != join_dht_node_port:
        print("    depends_on:", file=config_file)
        print(f"      - {dht_algorithm}-node-{join_dht_node_port}", file=config_file)


# ------------------------------------------------------------------------------
def generate(algorithm, port_start, port_end):
    print(
        f'Generate config script for DHT nodes using algorithm "{algorithm}" with ports between including "{port_start}" and "{port_end}"...',
        end="",
    )

    port_end += 1

    with open(
        f"config/{algorithm}-network.bat", "w", newline="\n"
    ) as batch_script, open(
        f"config/{algorithm}-network.sh", "w", newline="\n"
    ) as bash_script, open(
        f"config/{algorithm}-network.yml", "w", newline="\n"
    ) as config_file:

        print(
            f"""@echo off
@REM Generated by `{os.path.relpath(__file__)}`

setlocal
set "SCRIPT_PATH=%~dp0"
set "SCRIPT_PATH=%SCRIPT_PATH:~0,-1%"
cd /d "%SCRIPT_PATH%"

docker-compose ^
    --env-file ../../.env ^
    -f ./{algorithm}-network.yml ^
    %*
endlocal""",
            file=batch_script,
        )

        print(
            f"""#!/usr/bin/env sh
# Generated by `{os.path.relpath(__file__)}`

(
SCRIPT_DIR=`dirname "$0"`
SCRIPT_DIR=`realpath "$SCRIPT_DIR"`
cd "$SCRIPT_DIR"

docker-compose \\
    --env-file ../../.env \\
    -f ./{algorithm}-network.yml \\
    $@
)""",
            file=bash_script,
        )

        head_lines, body_lines = read_template()

        print(f"# Generated by `{os.path.relpath(__file__)}`\n", file=config_file)

        for line in head_lines:
            print(line.format(dht_algorithm=algorithm), end="", file=config_file)

        for port in range(port_start, port_end):
            generate_entry(config_file, body_lines, algorithm, port, port_start)

        print(" Done.")


# ------------------------------------------------------------------------------
if __name__ == "__main__":
    # Change the working directory to the one this script resides in.
    os.chdir(os.path.abspath(os.path.dirname(__file__)))

    for index, arg in enumerate(sys.argv):
        try:
            parts = arg.split("=")
            algorithm = parts[0]
            ports = parts[1].split(":")
            portStart = int(ports[0])
            portEnd = int(ports[1])

            # Generate node config for the given algorithm and port range.
            generate(algorithm, portStart, portEnd)
        except:
            pass
